
'-------------------------------------------------------------------------------
' CubeAtHome
' with a PIC16F877A
'
' Written by Wauters Kris - november, 15th - 2007
'-------------------------------------------------------------------------------
											 
'-------------------------------------------------------------------------------
'--- PIC related                                                             ---
'-------------------------------------------------------------------------------
OPTIMISER_LEVEL = 0

Device = 16F877A 			    'use the 16F877A PIC
XTAL = 20						'at 20 Mhz
ALL_DIGITAL = true				'all pins ar digital


'-------------------------------------------------------------------------------
'--- general variables                                                       ---
'-------------------------------------------------------------------------------
Dim a As Byte
'Dim b As Byte
Dim c As Byte
'Dim d As Byte
Dim I As DWord
Dim IX As Byte
Dim ticker As Word
Dim test As DWord
Dim writeloop As Byte
Dim IdNr As Byte
Dim Value[9] As Byte
Dim InfraRedFound As Bit

Dim BitMusic As Bit
Dim BitDisplay As Bit
Dim BitConnected As Bit
Dim BitConnectSet As Bit
Dim BitSetBrightness As Bit

Dim Pos As Byte
Dim PosVal[12] As Byte
Dim PosTemp[12] As Byte
Dim LineNr As Byte
Dim PosAdd As Byte
Dim PosNew As Byte

'-------------------
'--- definitions ---
'-------------------

'--- controle LEDs ---
Output PORTD.4  ' LED 1
Output PORTD.5  ' LED 2
Output PORTD.6  ' LED 3
Symbol LedRed = PORTD.7
Symbol LedYellow = PORTD.6
Symbol LedGreen = PORTD.5

'--- led matrix + controle LED ---
Output PORTD.2      'data in
Output PORTD.3      'controle LED 
Output PORTC.4      'data load
Output PORTC.5      'data clk
Symbol DataIn = PORTD.2
Symbol DataLoad = PORTC.4
Symbol DataClk = PORTC.5
Symbol ControleLED = PORTD.3
Dim LedBrightness As Byte

'--- sound ---
Output PORTD.6
Output PORTD.7
Symbol SndPin1 = PORTB.6
Symbol SndPin2 = PORTB.7

'--- infrared ---
Dim Header As Word
Dim Packet As Header
Dim P_Val As Byte
Dim IR_But As Byte
Dim IR_Dev As Byte
Dim Sony_LP As Byte
Symbol IR_Sensor = PORTA.1

'--- temperature sensor DS1820 ---
Symbol DQ     = PORTA.2             ' Alias DS1820 data pin
Symbol DQ_DIR = TRISA.2             ' Alias DS1820 data direction pin
Dim command         As Byte         ' Storage for command
Dim InitTemp        As Byte                   
Dim TempLeft        As Byte
Dim TempRight       As Byte
Dim Temp            As Word         'Storage for temperature

'--- RTC Clock DS1302 declaration ---
Symbol SCLK	= PORTE.0
Symbol IO	= PORTE.1
Symbol RST  = PORTE.2
Dim RtcYear         As Byte
Dim RtcDay          As Byte
Dim RtcMonth        As Byte
Dim RtcDate         As Byte
Dim RtcHr           As Byte
Dim RtcMin          As Byte
Dim RtcSec          As Byte
Dim RtcControl      As Byte
Dim SecondsMemory   As Byte
Dim TmpSeconds      As Byte

'--- LCD ---
Output PORTB.0
Output PORTB.1
Output PORTB.2
Output PORTB.3
Output PORTB.4
Output PORTB.5
Output PORTA.0
Declare LCD_DTPIN PORTB.0		'use B0-B3 	(PIC) for D4-D7 	(LCD)
Declare LCD_RSPIN PORTB.5 		'use B5 	(PIC) for R/S	 	(LCD)
Declare LCD_ENPIN PORTB.4 		'use B4  	(PIC) for enable 	(LCD)
Declare LCD_INTERFACE 4		    'use LCD in 4bit mode
Declare LCD_LINES 4				'use a 4-line LCD
Declare LCD_TYPE 0				'0 = alphanumeric
Symbol LCDBacklight = PORTA.0

'--- MMC related ---
Symbol SD_CS  = PORTD.1
Symbol SD_DI  = PORTD.0
Symbol SD_CLK = PORTC.2
Symbol SD_DO  = PORTC.3	

Dim SD_Buffer_Idx As Word                                                       'Current position in buffer
Dim SD_ByteR As Byte  
Dim SD_Seek_Response_Idx As Word                                                'Index in SD_Seek_Response
Dim SD_Address As DWord                                                         'Byte address
Dim SD_Sector_Num As DWord                                                      'Sector number for read/write
Dim SD_Byte0 As Byte                                                            
Dim SD_Byte1 As Byte
Dim SD_Byte2 As Byte
Dim SD_Byte3 As Byte
Dim SD_Byte4 As Byte
Dim SD_Byte5 As Byte
Dim SD_Seek_Response_Reqd As Byte                                               'Required byte returned from Cmd
Dim SD_Seek_Response_Return As Byte                                             'Return flag from SD_Seek_Response: 0 = OK, 1 = Timeout
Dim SD_Return As Byte                                                           'Return flag from Subroutine: 0 = OK, 1 = Timeout
Dim SD_Idx As Byte                                                              'General index byte
Dim SD_Buffer0[$2] As Byte                                                    'Read/write buffer - L
Dim SD_Buffer1[$2] As Byte                                                    'Read/write buffer - H

'--- on/off times for every day of the week ---
Dim OnHrs[8]         As Byte
Dim OnMins[8]        As Byte
Dim OffHrs[8]        As Byte
Dim OffMins[8]       As Byte
Dim ActualOnHrs[8]   As Byte
Dim ActualOffHrs[8]  As Byte
Dim ActualOnMins[8]  As Byte
Dim ActualOffmins[8] As Byte
Dim CurDay           As Byte

'--- RS232 related ---
Input PORTD.4
Symbol RS232Connected = PORTD.4
Declare RSOUT_PIN PORTC.6
Declare RSIN_PIN PORTC.7
Declare SERIAL_BAUD 38000
Declare RSOUT_PACE = 1
Declare RSIN_TIMEOUT = 5000

'-------------------------------------------------------------------------------
'--- startup                                                                 ---
'-------------------------------------------------------------------------------

    '--- turn RED LED on at startup ---
    High LedRed
    Print At 1,1," -=[Cube at Home]=- "
    Print At 2,1,"                    "
    Print At 3,1," even geduld a.u.b. "
    Print At 4,1,"                    "
    
    '--- init some variables ---
    BitConnected = 0
    BitConnectSet = 0
    BitMusic = 1
    BitDisplay = 1
    BitSetBrightness = 1
    I = 0
    IdNr = 1
    LedBrightness = ERead 0  
    If LedBrightness > $0F Then LedBrightness = $0F  
    Repeat
        Inc I
        ActualOnHrs[I]   = ERead IdNr    : If ActualOnHrs[I]   > $23 Then ActualOnHrs[I]   = $00  
        ActualOnMins[I]  = ERead IdNr + 1: If ActualOnMins[I]  > $59 Then ActualOnMins[I]  = $00 
        ActualOffHrs[I]  = ERead IdNr + 2: If ActualOffHrs[I]  > $23 Then ActualOffHrs[I]  = $00
        ActualOffmins[I] = ERead IdNr + 3: If ActualOffmins[I] > $59 Then ActualOffmins[I] = $00
        IdNr = IdNr + 4
    Until I = 7


    '--- initialise LED matrix ---
    IdNr=$0C:Value[1]=$01:GoSub SetNext7:GoSub WriteData:        '--- init             ---
    IdNr=$09:Value[1]=$00:GoSub SetNext7:GoSub WriteData:        '--- init decode mode ---
    IdNr=$0B:Value[1]=$07:GoSub SetNext7:GoSub WriteData:        '--- init scanlimit   ---
    GoSub SetMatrixBrightNess:
    IdNr=$0F:Value[1]=$01:GoSub SetNext7:GoSub WriteData:        '--- init testmode    ---
    DelayMS 250
    IdNr=$0F:Value[1]=$00:GoSub SetNext7:GoSub WriteData:        '--- init do-it-mode  ---
    DelayMS 250

    '--- clear LED matrix ---
    a=0:
    Repeat
        Inc a
        Value[a] = 0
    Until a = 8
    a=0:
    Repeat
        Inc a
        IdNr = a:GoSub WriteData
    Until a = 8
    DelayMS 200


    '--- startup sound ---
    Sound2 SndPin1,SndPin2,[1000\0\250]
    Sound2 SndPin1,SndPin2,[2000\0\250]
    Sound2 SndPin1,SndPin2,[3000\0\250]
    High LCDBacklight

    '--- turn YELLOW LED on (halfway the startup procedure ---
    Low LedRed:High LedYellow

    '--- initialise LCD ---
    GoSub UpdateCustomChars:
    Print At 1,1,0,1," [Cube at Home] ",2,3
    Print At 3,1,"                    "
    
    '--- do init of clock ---
    Low DataIn
    Low DataLoad
    Low DataClk
    
    
    GoSub InitClock:
    '--- we are trough the startup procedure, set green LED on ---
    Low LedYellow:High LedGreen
    
'-------------------------------------------------------------------------------
'--- main application                                                        ---
'-------------------------------------------------------------------------------

'GoSub TestMMC:

Hoofdlus:
    GoSub DoAnimation
GoTo Hoofdlus:


TestMMC:
    GoSub SD_Init_Sub:
    DelayMS 1000
Test2:
    For I = 129 To 136
        'Print At 4,1,DEC4 I
        SD_Sector_Num = I
        GoSub SD_Read_Sector:
        DelayMS 50
    Next I
    GoTo Test2:
Return


'-------------------------------------------------------------------------------
'--- update custom characters for LCD                                        ---
'-------------------------------------------------------------------------------
UpdateCustomChars:
    If BitConnected = 1 Then
        Print $FE,$40,$00,$04,$0E,$1F,$1F,$0E,$04,$00		'karakter 0 => connected
    Else
        Print $FE,$40,$00,$0A,$1B,$1B,$1B,$1B,$0A,$00		'karakter 0 => not connected
    EndIf
    If BitMusic = 1 Then
        Print $FE,$48,$0F,$09,$0F,$09,$19,$1B,$03,$00		'karakter 1 => muzieknoot
    Else
        Print $FE,$48,$00,$11,$0A,$04,$0A,$11,$00,$00		'karakter 1 => groot kruis
    EndIf
    If BitDisplay = 1 Then
        Print $FE,$50,$00,$0E,$1F,$1F,$1F,$0E,$00,$00       'karakter 2 => display aan
    Else
        Print $FE,$50,$00,$11,$0A,$04,$0A,$11,$00,$00		'karakter 2 => groot kruis
    EndIf
    
    '--- brightness level - karakter 3 ---
    IX = 18
    Print $FE,$58
    Repeat
        IX = IX - 2
        If IX <= LedBrightness Then
            Print $1F
        Else
            Print $00
        EndIf
    Until IX = 0
 
    Print $FE,$60,$00,$0E,$0A,$0A,$0A,$0A,$0E,$00		'karakter 4 => slider
    Print $FE,$68,$00,$00,$00,$0E,$0E,$00,$00,$00		'karakter 5 => dot voor slider
    Print $FE,$70,$0C,$12,$12,$0C,$00,$00,$00,$00		'karakter 6 => graden symbool
Return

'-------------------------------------------------------------------------------
'--- set brightness of LED matrix                                            ---
'-------------------------------------------------------------------------------
SetMatrixBrightNess:
    EWrite 0,[LedBrightness]
    Print At 2,1,"  ",5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,"  "
    Print At 2,LedBrightness + 3,4
    BitSetBrightness = 1            'set bit, so first thing animation will do, is update the brightness
    GoSub UpdateCustomChars: 
    DelayMS 500
Return

'-------------------------------------------------------------------------------
'--- check infrared and get date, time & temperature into variables          ---
'-------------------------------------------------------------------------------
CheckIRDateTimeTemp:
    GoSub CheckInfraRed 'check if an infrared-signal is incomming
    If InfraRedFound = 1 Then   'if so, then do a small beep (if bitmusic=1)
        If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[1000\0\20]
        Repeat          'wait for end of IR signal
            GoSub CheckInfraRed
        Until InfraRedFound = 0
        I = 0
        Repeat          'read a full IR command
            Inc I 
            GoSub ReadInfraRed
        Until IR_Dev <> 255 Or I > 10
        If IR_Dev <> 255 Then
            Select Case IR_But  'according received IR-signal from a remote command button, do actions
                Case 65        'turn matrix a bit brighter
                    If LedBrightness < $0F Then LedBrightness=LedBrightness+1
                    GoSub SetMatrixBrightNess:
                Case 64        'turn matrix a bit darker
                    If LedBrightness > $00 Then LedBrightness=LedBrightness-1
                    GoSub SetMatrixBrightNess:
                Case 20         '(un)mute or unmute sound 
                    BitMusic = 1 - BitMusic
                    GoSub UpdateCustomChars:
                Case 22         'turn matrix on or off
                    BitDisplay = 1 - BitDisplay
                    GoSub UpdateCustomChars:
                Case $6C         'adjust time
                    LineNr = 3:PosAdd = 12:Pos = 1
                    StrN PosVal = " 12:12:12  "
                    StrN PosTemp = " --:--:--  " 
                    GoSub AdjustIt:
                Case $68         'adjust date
                    LineNr = 4:PosAdd = 10:Pos = 1
                    StrN PosVal = "101/01/2007"
                    StrN PosTemp = "_--/--/20--"
                    GoSub AdjustIt:
                Case 23         'adjust on/off times
                    CurDay = RtcDay
                    GoSub AdjustOnOffTime:
            End Select
            'Print At 2,1,HEX2 IR_But
            'DelayMS 1000
            'Print At 2,1,"  "
        EndIf
    EndIf
    GoSub PutDateTimeAndTempInVariables:
    '--- only update LCD display if time is changed (so do this every second)
    If TmpSeconds <> RtcSec Then
        TmpSeconds = RtcSec
        'print at 2,1,hex2 offhrs[rtcday],"*",hex2 onhrs[rtcday],"*",hex2 rtchr," ",hex2 offmins[rtcday],"*",hex2 onmins[rtcday],"*",hex2 rtcmin
        If OffHrs[RtcDay] = RtcHr And OffMins[RtcDay] = RtcMin Then 
            If BitDisplay = 1 Then
                BitDisplay = 0
                If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[1000\0\20]
                GoSub UpdateCustomChars:
            EndIf
        EndIf
        If OnHrs[RtcDay] = RtcHr And OnMins[RtcDay] = RtcMin Then 
            If BitDisplay = 0 Then
                BitDisplay = 1
                If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[1000\0\20]
                GoSub UpdateCustomChars:
            EndIf
        EndIf        
        Select Case RtcDay
            Case $01:Print At 4,1,"maandag   "
            Case $02:Print At 4,1,"dinsdag   "
            Case $03:Print At 4,1,"woensdag  "
            Case $04:Print At 4,1,"donderdag "
            Case $05:Print At 4,1,"vrijdag   "
            Case $06:Print At 4,1,"zaterdag  "
            Case $07:Print At 4,1,"zondag    "
        End Select
        Print At 4,11,HEX2 RtcDate,"/",HEX2 RtcMonth,"/20",HEX2 RtcYear
        Print At 3,13,HEX2 RtcHr,":",HEX2 RtcMin,":",HEX2 RtcSec
        '--- if the temperature is read (needs allmost 10 seconds), then also update this on the LCD
        If RtcSec = $10 And InitTemp = 4 Then
            Print At 3,1, DEC2 TempLeft, "." , DEC1 TempRight," ",6,"C"
            InitTemp = 0
        EndIf
    EndIf    
Return

'-------------------------------------------------------------------------------
'--- give possibility to set the time for turning the cube on and off        ---
'-------------------------------------------------------------------------------
AdjustOnOffTime:  
    Print At 2,1,"aan=--:--  uit=--:--"
    Print At 4,1,"Ma-Di-Wo-Do-Vr-Za-Zo"
    Print $FE,$0F
    Pos = 1
    I = 0
    Repeat
        Inc I 
        OnHrs[I]   = ActualOnHrs[I]
        OnMins[I]  = ActualOnMins[I]
        OffHrs[I]  = ActualOffHrs[I]
        OffMins[I] = ActualOffmins[I]
    Until I = 7
        
AdjustOnOffTimeLoop:    
    Print At 3,1,"                    "
    Print At 3,(curday*3)-2,"__"
    Print At 2,5, HEX2 OnHrs[CurDay]
    Print At 2,16,HEX2 OffHrs[CurDay]
    Print At 2,8, HEX2 OnMins[CurDay]
    Print At 2,19,HEX2 OffMins[CurDay]
    Select Case Pos
        Case 1:Cursor 2,5
        Case 2:Cursor 2,8
        Case 3:Cursor 2,16
        Case 4:Cursor 2,19
    End Select
    Repeat
        GoSub ReadInfraRed:
    Until IR_Dev <> 255
    If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[1000\0\20]
    DelayMS 250
    If IR_But = 16 Then 
        Select Case Pos
            Case 1
                Inc OnHrs[CurDay] 
                If OnHrs[CurDay] = $0A  Then OnHrs[CurDay] = $10
                If OnHrs[CurDay] = $1A  Then OnHrs[CurDay] = $20
                If OnHrs[CurDay] > $23  Then OnHrs[CurDay] = $00
            Case 2
                Inc OnMins[CurDay] 
                If OnMins[CurDay] = $0A Then OnMins[CurDay] = $10
                If OnMins[CurDay] = $1A Then OnMins[CurDay] = $20
                If OnMins[CurDay] = $2A Then OnMins[CurDay] = $30
                If OnMins[CurDay] = $3A Then OnMins[CurDay] = $40
                If OnMins[CurDay] = $4A Then OnMins[CurDay] = $50
                If OnMins[CurDay] > $59 Then OnMins[CurDay] = $00
            Case 3
                Inc OffHrs[CurDay]
                If OffHrs[CurDay] = $0A  Then OffHrs[CurDay] = $10
                If OffHrs[CurDay] = $1A  Then OffHrs[CurDay] = $20
                If OffHrs[CurDay] > $23  Then OffHrs[CurDay] = $00
            Case 4
                Inc OffMins[CurDay] 
                If OffMins[CurDay] = $0A Then OffMins[CurDay] = $10
                If OffMins[CurDay] = $1A Then OffMins[CurDay] = $20
                If OffMins[CurDay] = $2A Then OffMins[CurDay] = $30
                If OffMins[CurDay] = $3A Then OffMins[CurDay] = $40
                If OffMins[CurDay] = $4A Then OffMins[CurDay] = $50
                If OffMins[CurDay] > $59 Then OffMins[CurDay] = $00
        End Select
    EndIf
    If IR_But = 17 Then
        Select Case Pos
            Case 1: 
                If OnHrs[CurDay] > $00 Then 
                    Dec OnHrs[CurDay]
                    If OnHrs[CurDay] = $1F Then OnHrs[CurDay] = $19
                    If OnHrs[CurDay] = $0F Then OnHrs[CurDay] = $09
                Else
                    OnHrs[CurDay] = $23
                EndIf
            Case 2: 
                If OnMins[CurDay] > $00 Then 
                    Dec OnMins[CurDay]
                    If OnMins[CurDay] = $4F Then OnMins[CurDay] = $49
                    If OnMins[CurDay] = $3F Then OnMins[CurDay] = $39
                    If OnMins[CurDay] = $2F Then OnMins[CurDay] = $29
                    If OnMins[CurDay] = $1F Then OnMins[CurDay] = $19
                    If OnMins[CurDay] = $0F Then OnMins[CurDay] = $09
                Else
                    OnMins[CurDay] = $59
                EndIf
            Case 3: 
                If OffHrs[CurDay] > $00 Then 
                    Dec OffHrs[CurDay]
                    If OffHrs[CurDay] = $1F Then OffHrs[CurDay] = $19
                    If OffHrs[CurDay] = $0F Then OffHrs[CurDay] = $09
                Else
                    OffHrs[CurDay] = $23
                EndIf
            Case 4: 
                If OffMins[CurDay] > $00 Then 
                    Dec OffMins[CurDay]
                    If OffMins[CurDay] = $4F Then OffMins[CurDay] = $49
                    If OffMins[CurDay] = $3F Then OffMins[CurDay] = $39
                    If OffMins[CurDay] = $2F Then OffMins[CurDay] = $29
                    If OffMins[CurDay] = $1F Then OffMins[CurDay] = $19
                    If OffMins[CurDay] = $0F Then OffMins[CurDay] = $09
                Else
                    OffMins[CurDay] = $59
                EndIf
        End Select
    EndIf                
    If IR_But = 13 Then Inc CurDay
    If IR_But = 72 Then Dec CurDay
    If IR_But = 18 Then Inc Pos
    If IR_But = 19 Then Dec Pos
    If Pos > 4 Then Pos = 1
    If Pos < 1 Then Pos = 4
    If CurDay < 1 Then CurDay = 7
    If CurDay > 7 Then CurDay = 1
    If IR_But = 73 Then          '--- save ---
        Print $FE, $0C
        I = 0
        IdNr = 1
        Repeat
            Inc I
            ActualOnHrs[I]   = OnHrs[I]
            ActualOnMins[I]  = OnMins[I]
            ActualOffHrs[I]  = OffHrs[I]
            ActualOffmins[I] = OffMins[I]
            EWrite IdNr    ,[ActualOnHrs[I]]
            EWrite IdNr + 1,[ActualOnMins[I]]
            EWrite IdNr + 2,[ActualOffHrs[I]]
            EWrite IdNr + 3,[ActualOffmins[I]]
            IdNr = IdNr + 4
        Until I = 7
    EndIf
    If IR_But = 74 Or IR_But = 73 Then
        GoSub CleanUpDisplay:
        Return
    EndIf
GoTo AdjustOnOffTimeLoop:


'--- clear display after "mess" ;-) ---
CleanUpDisplay:
    Print $FE, $0C
    Print At 2,1,"                    "
    Print At 3,1,"                    "
    Print At 4,1,"                    "
Return   

'-------------------------------------------------------------------------------
'--- give possibility to adjust time or date                                 ---
'-------------------------------------------------------------------------------
AdjustIt:
    If PosTemp[0] = "_" Then 
        Print At 4,1,"maandag   "
        IdNr = 10
    Else
        IdNr = 8
    EndIf
    I = 1
    Repeat
        Inc I 
        Print At LineNr,PosAdd + I,PosVal[I]
    Until I = IdNr
    Print $FE,$0F
AdjustItLoop:
    If Pos <> 0 Then
        Cursor LineNr,Pos + PosAdd
    Else
        Cursor LineNr,1
    EndIf
    Repeat
        GoSub ReadInfraRed 
    Until IR_Dev <> 255
    If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[1000\0\20]
    DelayMS 250
    If PosTemp[0] = "_" And Pos = 0 Then
        If IR_But = 16 Then PosVal[0] = PosVal[0]+1
        If IR_But = 17 Then PosVal[0] = PosVal[0]-1
        If PosVal[0] > 7 Then PosVal[0] = 1
        If PosVal[0] < 1 Then PosVal[0] = 7
        Select Case PosVal[0]
            Case 1:Print "maandag   " 
            Case 2:Print "dinsdag   "
            Case 3:Print "woensdag  "
            Case 4:Print "donderdag "
            Case 5:Print "vrijdag   "
            Case 6:Print "zaterdag  "
            Case 7:Print "zondag    "            
        End Select
    EndIf
    PosNew = 0
    If IR_But = 18 Then PosNew = 1 
    If IR_But = 19 Then PosNew = 2
    If IR_But < 9 Then PosVal[Pos] = IR_But + 1
    If IR_But = 9 Then PosVal[Pos] = 0
    If IR_But < 10 Then Print At LineNr,Pos + PosAdd,DEC1 PosVal[Pos]
    If IR_But = 9 Then
        PosVal[Pos] = 0
        Print At LineNr,Pos + PosAdd,DEC1 0
    EndIf        
    Repeat
        If Pos = 0 And PosNew = 2 Then 
            Pos = 10
        Else
            If PosNew = 1 Then Inc Pos
            If PosNew = 2 Then Dec Pos
        EndIf 
        If Pos > 10 And PosTemp[0]<> "_" Then Pos = 1
        If Pos > 10 And PosTemp[0]= "_" Then Pos = 0            
        If Pos < 1 And PosTemp[0] <> "_" Then Pos = 10
    Until PosTemp[Pos] = "-" Or PosTemp[Pos] = "_"
    If IR_But = 73 Then          '--- save time or date   ---
        If PosTemp[0] = "_" Then    '--- adjust date ---
            GoSub GetTime:
            RtcDay = PosVal[0]
            RtcDate =  (PosVal[1] * 16) + PosVal[2]
            RtcMonth = (PosVal[4] * 16) + PosVal[5]
            RtcYear =  (PosVal[9] * 16) + PosVal[10]
            GoSub SetTime:
        Else                        '--- adjust time ---
            GoSub GetTime:
            RtcHr =  (PosVal[1] * 16) + PosVal[2]
            RtcMin = (PosVal[4] * 16) + PosVal[5]
            RtcSec = (PosVal[7] * 16) + PosVal[8]
            GoSub SetTime:            
        EndIf
    EndIf
    If IR_But = 73 Or IR_But = 74 Then
        GoSub CleanUpDisplay:
        Return
    EndIf
GoTo AdjustItLoop:

'-------------------------------------------------------------------------------
'--- do actual animation on LED matrix                                       ---
'-------------------------------------------------------------------------------
DoAnimation:
    If BitSetBrightness = 1 Then    '--- update the actual brightness on the LED matrix when brightness-bit is set
        IdNr=$0A:Value[1]=LedBrightness:GoSub SetNext7:GoSub WriteData:
        BitSetBrightness = 0
    EndIf
    If RS232Connected = 0 Then
        BitConnected = 1
        If BitConnectSet = 0 Then
            If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[2000\0\500]
            GoSub UpdateCustomChars
            BitConnectSet = 1
        EndIf
        '--- pin will be tied to GND, if cable is connected, so we have a connection ---
        'Print At 2,1," RS232 verbinding ! "
        IdNr=0
        Repeat
            Inc IdNr
            c=0
            Repeat
                Inc c
                RSIn Value[c]
            Until c = 8
            GoSub WriteData
        Until IdNr = 8    
        GoSub CheckIRDateTimeTemp
    Else
        '--- continue with current animation --- 
        BitConnected = 0
        If BitConnectSet = 1 Then
            If BitMusic = 1 Then Sound2 SndPin1,SndPin2,[2000\0\500]
            GoSub UpdateCustomChars
            BitConnectSet = 0
        EndIf       
        Print At 2,1,"                    "
        ticker = 0
        a=0
        Repeat
            Inc a
            IdNr = 0
            Repeat
                Inc IdNr
                c=0
                Repeat
                    Inc c
                    '--- mute display if necessary ---
                    If BitDisplay = 1 Then
                        Value[c] = LRead CorkScrew + ticker
                    Else
                        Value[c] = 0
                    EndIf
                    Inc ticker
                Until c = 8
                GoSub WriteData
            Until IdNr = 8
            GoSub CheckIRDateTimeTemp
            DelayMS 60
        Until a = 14
    EndIf
Return

'-------------------------------------------------------------------------------
'--- write actual data to LED matrix                                         ---
'-------------------------------------------------------------------------------
WriteData:
    Low DataLoad
        writeloop = 8
        Repeat
            SHOut DataIn,DataClk,msbfirst,[IdNr]
            SHOut DataIn,DataClk,msbfirst,[Value[writeloop]]
            writeloop = writeloop - 1
        Until writeloop < 1            
    High DataLoad
    DelayUS 10
    Low DataLoad
Return

'-------------------------------------------------------------------------------
'--- set all values the same, so we can update the whole LED matrix          ---
'-------------------------------------------------------------------------------
SetNext7:
    a = 0
    Repeat
        Inc a
        Value[a] = Value[1]    
    Until a = 8
Return

'-------------------------------------------------------------------------------
'--- check for infrared signal                                               ---
'-------------------------------------------------------------------------------
CheckInfraRed:
    InfraRedFound = 0
    IX = 0
    Repeat
        Inc IX
        If IR_Sensor = 0 Then InfraRedFound = 1 'Houston, we have an incomming IR signal !
    Until IX = 10 Or InfraRedFound = 1
Return

'-------------------------------------------------------------------------------
'--- read infrared signal                                                    ---
'-------------------------------------------------------------------------------
ReadInfraRed:
    '--- check if signal available ---
    Set IR_Dev
    Set IR_But
    Header = PulsIn IR_Sensor,Low
    If Header < 600 Or Header > 2350 Then Return
    '--- actually receive signal ---
    Clear Sony_LP
    Repeat
        Clear Packet.11
        If PulsIn IR_Sensor,Low >=750 Then Set Packet.11
        Packet = Packet >>1
        Inc Sony_LP
    Until Sony_LP = 11
    '--- split data into device and button code ---
    IR_But = Packet & %01111111
    Packet = Packet <<1
    IR_Dev = Packet.HighByte & %00011111
Return

'-------------------------------------------------------------------------------
'--- Initialise the RealTimeClock when starting up                           ---
'--- when clock is not running previously, set it to 01/01/2008 12:12:12     ---
'-------------------------------------------------------------------------------
InitClock:
    DelayMS 150
    Low RST                         ' Reset RTC
    Low SCLK
    DelayMS 150

    GoSub GetTime:
    TmpSeconds = RtcSec
    DelayMS 2000
    GoSub GetTime:
    If TmpSeconds = RtcSec Then 'clock is not running previously
        RtcYear = $07
        RtcDay = $01
        RtcMonth = $01
        RtcDate = $02
        RtcHr = $12
        RtcMin = $12
        RtcSec = $12
        GoSub SetTime:
    EndIf
Return 

'-------------------------------------------------------------------------------
'--- Read Time from RTC                                                      ---
'-------------------------------------------------------------------------------
GetTime:
        RST = 1         					' Ready for transfer
        DelayMS 1
        SHOut IO,SCLK,lsbfirst,[$bf]     	' Read all 8 RTC registers in burst mode
        DelayMS 1
        SHIn IO,SCLK,lsbpre,[RtcSec,RtcMin,RtcHr,RtcDate,RtcMonth,RtcDay,RtcYear,RtcControl]
        DelayMS 1
        RST = 0         					' Reset RTC
        DelayMS 1
Return     

'-------------------------------------------------------------------------------
'--- write time to RTC                                                       ---
'-------------------------------------------------------------------------------
SetTime:
        RST = 1         					' Ready for transfer
        SHOut IO,SCLK,lsbfirst,[$8e,0]		' Enable write
        RST = 0         					' Reset RTC
        RST = 1         					' Ready for transfer
' Write all 8 RTC registers in burst mode
        SHOut IO,SCLK,lsbfirst,[$be,RtcSec,RtcMin,RtcHr,RtcDate,RtcMonth,RtcDay,RtcYear,0]
        RST = 0         					' Reset RTC
        RST = 1
        SHOut IO,SCLK,lsbfirst,[$90,%10100101]
        RST = 0
Return

'-------------------------------------------------------------------------------
'--- Get time and accordingly, try to retrieve the temperature               ---
'-------------------------------------------------------------------------------
PutDateTimeAndTempInVariables:
    GoSub GetTime:
    If SecondsMemory <> RtcSec Then
        SecondsMemory = RtcSec                
        '--- get temperature ---
        If RtcSec = $01 Then GoSub InitTempReading:
        If RtcSec = $04 And InitTemp = 1 Then GoSub PrepareTempReading:
        If RtcSec = $07 And InitTemp = 2 Then GoSub BeforeShowTempReading:
        If RtcSec = $10 And InitTemp = 3 Then GoSub GetTempReading:
    EndIf
Return

'-------------------------------------------------------------------------------
'--- STEP 1 of 4 - initialise reading of temperature                         ---
'-------------------------------------------------------------------------------
InitTempReading:
    Low DQ                  ' Set the data pin low to init
    DelayUS 900             ' Wait > 480us
    DQ_DIR = 1              ' Release data pin (set to input for high)
    DelayUS 200             ' Wait > 60us
    If DQ = 1 Then
        InitTemp = 0
        Return
    EndIf
    InitTemp = 1
Return

'-------------------------------------------------------------------------------
'--- STEP 2 OF 4 - prepare for reading of temperature                        ---
'-------------------------------------------------------------------------------
PrepareTempReading:
    command = $cc           ' Issue Skip ROM command
    GoSub write1820
    command = $44           ' Start temperature conversion
    GoSub write1820
    InitTemp = 2
Return

'-------------------------------------------------------------------------------
'--- STEP 3 OF 4 - just before the actual reading of temperature             ---
'-------------------------------------------------------------------------------
BeforeShowTempReading:
    Low DQ                  ' Set the data pin low to init
    DelayUS 900             ' Wait > 480us
    DQ_DIR = 1              ' Release data pin (set to input for high)
    DelayUS 200             ' Wait > 60us
    If DQ = 1 Then
        InitTemp = 0
        Return
    EndIf
    InitTemp = 3
Return

'-------------------------------------------------------------------------------
'--- STEP 4 OF 4 - finally, get the temperature into variables               ---
'-------------------------------------------------------------------------------
GetTempReading:
    command = $cc           ' Issue Skip ROM command
    GoSub write1820
    command = $be           ' Read the temperature
    GoSub write1820
    GoSub read1820
    TempLeft = Temp >> 1
    TempRight = Temp.0 * 5
    TempLeft = TempLeft - 3    
    'str StrTemp = Str$(DEC2 TempLeft) + "." + Str$(DEC1 TempRight),0  
    InitTemp = 4         
Return

'-------------------------------------------------------------------------------
'--- Write "command" byte to the DS1820                                      ---
'-------------------------------------------------------------------------------
write1820:
    For I = 1 To 8          ' 8 bits to a byte
        If command.0 = 0 Then
            GoSub write0    ' Write a 0 bit
        Else
            GoSub write1    ' Write a 1 bit
        EndIf
        command = command >> 1  ' Shift to next bit
    Next I
Return

'-------------------------------------------------------------------------------
' --- Write a 0 bit to the DS1820                                            ---
'-------------------------------------------------------------------------------
write0:
    Low DQ
    DelayUS 200              ' Low for > 60us for 0
    DQ_DIR = 1              ' Release data pin (set to input for high)
Return

'-------------------------------------------------------------------------------
'--- Write a 1 bit to the DS1820                                             ---
'-------------------------------------------------------------------------------
write1:
    Low DQ                  ' Low for < 15us for 1
    DelayUS 1
    DQ_DIR = 1              ' Release data pin (set to input for high)
    DelayUS 200              ' Use up rest of time slot
Return

'-------------------------------------------------------------------------------
'--- Read data from the DS1820                                               ---
'-------------------------------------------------------------------------------
read1820:
    I = 0
    Repeat
        Inc I
        Temp = Temp >> 1    ' Shift down bits
        GoSub readbit       ' Get the bit to the top of temp
    Until I = 16
Return

'-------------------------------------------------------------------------------
' --- Read a bit from the DS1820                                             ---
'-------------------------------------------------------------------------------
readbit:
    Temp.15 = 1             ' Preset read bit to 1
    Low DQ                  ' Start the time slot
    DelayUS 10
    DQ_DIR = 1              ' Release data pin (set to input for high)
    If DQ = 0 Then
        Temp.15 = 0     ' Set bit to 0
    EndIf
    DelayUS 200              ' Wait out rest of time slot
Return

'*******************************************************************************
'*** READ RAW DATA FROM MMC CARD                                             ***
'*******************************************************************************

'------------------------------------------------------------------------------- 
'--- Initialise SD/MMC card - Setup direction For SPI bus                    ---
'-------------------------------------------------------------------------------
SD_Init_Sub:                                                     
    Output SD_CS : Output SD_DI : Output SD_CLK : Input SD_DO                   'Setup direction for SPI bus
	High SD_CS                                                                  'Pull CS high
    SD_Byte0 = $FF
    SD_Byte1 = $FF
    SD_Byte2 = $FF
    SD_Byte3 = $FF
    SD_Byte4 = $FF
    SD_Byte5 = $FF
	GoSub SD_Send_Cmd
	GoSub SD_Send_Cmd
'SD_Cmd0:                                                                       'SD/MMC Cmd 0 & CRC
    DelayMS 500
    Low SD_CS                                                                   'Pull CS low
    SD_Byte0 = $40
    SD_Byte1 = $00
    SD_Byte2 = $00
    SD_Byte3 = $00
    SD_Byte4 = $00
    SD_Byte5 = $95
	GoSub SD_Send_Cmd
	SD_Seek_Response_Reqd = $01
    GoSub SD_Seek_Response
    If SD_Seek_Response_Return = 1 Then
        High SD_CS
        SD_Return = 1                                                           'SD_Init Failed @ Cmd 0
        Return
    EndIf
'SD_Cmd1:                                                                       'SD/MMC Cmd 1 & CRC - Init from idle
	SD_Idx = $FF
    Repeat
        SD_Byte0 = $41
        SD_Byte1 = $00
        SD_Byte2 = $00
        SD_Byte3 = $00
        SD_Byte4 = $00
        SD_Byte5 = $FF
    	GoSub SD_Send_Cmd
	    SD_Seek_Response_Reqd = $00
        GoSub SD_Seek_Response
        Dec SD_Idx
	Until SD_Seek_Response_Return = 0 Or SD_Idx = 0
    If SD_Idx = 0 Then
        High SD_CS
        SD_Return = 1                                                           'SD_Init Failed @ Cmd 1
        Return
    EndIf
    High SD_CS
    SD_Byte5 = $FF
    GoSub SD_Send_Byte                                                          'Clock SD/MMC to complete job
    SD_Buffer_Idx = 0                                                           'Reset buffer index for R/W
    SD_Return = 0                                                               'SD_Init completed successfully
    Return
'------------------------------------------------------------------------------- 
'--- Send CMD                                                                ---    
'------------------------------------------------------------------------------- 
SD_Send_Cmd:
    SHOut SD_DI, SD_CLK, msbfirst, [SD_Byte0,SD_Byte1,SD_Byte2,SD_Byte3,SD_Byte4]
'------------------------------------------------------------------------------- 
'--- Send Byte                                                               ---
'------------------------------------------------------------------------------- 
SD_Send_Byte:
    SHOut SD_DI, SD_CLK, msbfirst, [SD_Byte5]
    Return
'------------------------------------------------------------------------------- 
'--- Receive Byte                                                            ---
'------------------------------------------------------------------------------- 
SD_Receive_Byte:
    SHIn SD_DO, SD_CLK, msbpre, [SD_ByteR]
    Return
'-------------------------------------------------------------------------------
'--- Wait for response from SD/MMC or timeout                                ---
'------------------------------------------------------------------------------- 
SD_Seek_Response:                                                               
    SD_Seek_Response_Idx = $FF
    Repeat
        GoSub SD_Receive_Byte
        Dec SD_Seek_Response_Idx	
    Until SD_ByteR = SD_Seek_Response_Reqd Or SD_Seek_Response_Idx = 0
    If SD_Seek_Response_Idx = 0 Then
        SD_Seek_Response_Return = 1                                             'SD_Return = 1: Timeout
    Else
        SD_Seek_Response_Return = 0                                             'SD_Return = 0: Response obtained
    EndIf
    Return                                                           
'-------------------------------------------------------------------------------
'--- Read Sector                                                             ---
'-------------------------------------------------------------------------------
SD_Read_Sector:                                                                 'Read from SD/MMC
	SD_Address = SD_Sector_Num << 9
'SD_Cmd17:
    Low SD_CS
    SD_Byte0 = $51
    SD_Byte1 = SD_Address.BYTE3
    SD_Byte2 = SD_Address.BYTE2
    SD_Byte3 = SD_Address.BYTE1
    SD_Byte4 = SD_Address.BYTE0
    SD_Byte5 = $FF
	GoSub SD_Send_Cmd
	DelayUS 5
	SD_Seek_Response_Reqd = $00
    GoSub SD_Seek_Response
    If SD_Seek_Response_Return = 1 Then
        High SD_CS
        SD_Return = 1                                                           'SD_Read Failed @ Cmd 17
        Return
    EndIf
'SD_Read_Start_Token:
	SD_Seek_Response_Reqd = $FE
	DelayUS 5
    GoSub SD_Seek_Response
    If SD_Seek_Response_Return = 1 Then
        High SD_CS
        SD_Return = 1                                                           'SD_Read Failed @ Start Token
        Return
    EndIf
'SD_Read_Data_Block:
    c = 0
    IdNr = 0
    For SD_Idx = 0 To $FF
	DelayUS 5
        GoSub SD_Receive_Byte                                                   'Read SD_Buffer0
        SD_Buffer0[1] = SD_ByteR
        If SD_Idx < 64 Then
            '--- write first 64 bytes to display ---
            Inc c
            Value[c] = SD_Buffer0[1]
            If c = 8 Then
                Inc IdNr
                GoSub WriteData
                c = 0
            EndIf    
        EndIf
    Next SD_Idx    
    For SD_Idx = 0 To $FF
	DelayUS 5
        GoSub SD_Receive_Byte                                                   'Read SD_Buffer1
        SD_Buffer1[1] = SD_ByteR
    Next SD_Idx    
'SD_Read_Dummy_CRC:        
    GoSub SD_Receive_Byte                                                       'Read dummy CRC to conclude data block
    GoSub SD_Receive_Byte                                     
    High SD_CS
    SD_Byte5 = $FF
    GoSub SD_Send_Byte                                                          'Clock SD/MMC to complete job
    SD_Return = 0                                                               'SD_Read completed successfully
    Return                                                                
'-------------------------------------------------------------------------------

CorkScrew:
LData As Byte 128,64,32,16,8,4,2,1,64,32,32,16,8,4,4,2,32,16,16,16,8,8,8,4,16,16,16,16,8,8,8,8,8,8,8,8,16,16,16,16,4,8,8,8,16,16,16,32,2,4,4,8,16,32,32,64,1,2,4,8,16,32,64,128
LData As Byte 64,32,16,8,4,2,1,0,32,32,16,8,4,4,2,1,16,16,16,8,8,8,4,2,16,16,16,8,8,8,8,12,8,8,8,16,16,16,16,48,8,8,8,16,16,16,32,64,4,4,8,16,32,32,64,128,2,4,8,16,32,64,128,0
LData As Byte 32,16,8,4,2,1,0,0,32,16,8,4,4,2,1,0,16,16,8,8,8,4,2,3,16,16,8,8,8,8,12,12,8,8,16,16,16,16,48,48,8,8,16,16,16,32,64,192,4,8,16,32,32,64,128,0,4,8,16,32,64,128,0,0
LData As Byte 16,8,4,2,1,0,0,0,16,8,4,4,2,1,0,0,16,8,8,8,4,2,3,0,16,8,8,8,8,12,12,15,8,16,16,16,16,48,48,240,8,16,16,16,32,64,192,0,8,16,32,32,64,128,0,0,8,16,32,64,128,0,0,0
LData As Byte 8,4,2,1,0,0,0,0,8,4,4,2,1,0,0,0,8,8,8,4,2,3,0,0,8,8,8,8,12,12,15,240,16,16,16,16,48,48,240,15,16,16,16,32,64,192,0,0,16,32,32,64,128,0,0,0,16,32,64,128,0,0,0,0
LData As Byte 4,2,1,0,0,0,0,0,4,4,2,1,0,0,0,0,8,8,4,2,3,0,0,192,8,8,8,12,12,15,240,48,16,16,16,48,48,240,15,12,16,16,32,64,192,0,0,3,32,32,64,128,0,0,0,0,32,64,128,0,0,0,0,0
LData As Byte 2,1,0,0,0,0,0,0,4,2,1,0,0,0,0,128,8,4,2,3,0,0,192,64,8,8,12,12,15,240,48,48,16,16,48,48,240,15,12,12,16,32,64,192,0,0,3,2,32,64,128,0,0,0,0,1,64,128,0,0,0,0,0,0
LData As Byte 1,0,0,0,0,0,0,128,2,1,0,0,0,0,128,64,4,2,3,0,0,192,64,32,8,12,12,15,240,48,48,16,16,48,48,240,15,12,12,8,32,64,192,0,0,3,2,4,64,128,0,0,0,0,1,2,128,0,0,0,0,0,0,1
LData As Byte 0,0,0,0,0,0,128,64,1,0,0,0,0,128,64,32,2,3,0,0,192,64,32,16,12,12,15,240,48,48,16,16,48,48,240,15,12,12,8,8,64,192,0,0,3,2,4,8,128,0,0,0,0,1,2,4,0,0,0,0,0,0,1,2
LData As Byte 0,0,0,0,0,128,64,32,0,0,0,0,128,64,32,32,3,0,0,192,64,32,16,16,12,15,240,48,48,16,16,16,48,240,15,12,12,8,8,8,192,0,0,3,2,4,8,8,0,0,0,0,1,2,4,4,0,0,0,0,0,1,2,4
LData As Byte 0,0,0,0,128,64,32,16,0,0,0,128,64,32,32,16,0,0,192,64,32,16,16,16,15,240,48,48,16,16,16,16,240,15,12,12,8,8,8,8,0,0,3,2,4,8,8,8,0,0,0,1,2,4,4,8,0,0,0,0,1,2,4,8
LData As Byte 0,0,0,128,64,32,16,8,0,0,128,64,32,32,16,8,0,192,64,32,16,16,16,8,240,48,48,16,16,16,16,8,15,12,12,8,8,8,8,16,0,3,2,4,8,8,8,16,0,0,1,2,4,4,8,16,0,0,0,1,2,4,8,16
LData As Byte 0,0,128,64,32,16,8,4,0,128,64,32,32,16,8,4,192,64,32,16,16,16,8,8,48,48,16,16,16,16,8,8,12,12,8,8,8,8,16,16,3,2,4,8,8,8,16,16,0,1,2,4,4,8,16,32,0,0,1,2,4,8,16,32
LData As Byte 0,128,64,32,16,8,4,2,128,64,32,32,16,8,4,4,64,32,16,16,16,8,8,8,48,16,16,16,16,8,8,8,12,8,8,8,8,16,16,16,2,4,8,8,8,16,16,16,1,2,4,4,8,16,32,32,0,1,2,4,8,16,32,64



