VERSION 5.00
Begin VB.Form Frm3DCube 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "3D Preview"
   ClientHeight    =   6150
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6150
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   410
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   410
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H00808080&
      ForeColor       =   &H80000008&
      Height          =   6150
      Left            =   0
      ScaleHeight     =   408
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   408
      TabIndex        =   0
      Top             =   0
      Width           =   6150
   End
End
Attribute VB_Name = "Frm3DCube"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim BoolStart As Boolean

Private Sub Form_Load()
  InitScreen
  BoolStart = True
End Sub

Private Sub InitScreen()
  BoolSolid = False
  LngLastF = GetTickCount()

  Full_Mat.m11 = 1
  Full_Mat.m22 = 1
  Full_Mat.m33 = 1
  Full_Mat.m44 = 1

  Axis_Points(1).m1 = 0
  Axis_Points(1).m2 = 0
  Axis_Points(1).m3 = 0
  Axis_Points(1).m4 = 1

  Axis_Points(2).m1 = 50
  Axis_Points(2).m2 = 0
  Axis_Points(2).m3 = 0
  Axis_Points(2).m4 = 1

  Axis_Points(3).m1 = 0
  Axis_Points(3).m2 = -50
  Axis_Points(3).m3 = 0
  Axis_Points(3).m4 = 1

  Axis_Points(4).m1 = 0
  Axis_Points(4).m2 = 0
  Axis_Points(4).m3 = 50
  Axis_Points(4).m4 = 1

  Axis_Lines(1).p1 = 1
  Axis_Lines(1).p2 = 2

  Axis_Lines(2).p1 = 1
  Axis_Lines(2).p2 = 3

  Axis_Lines(3).p1 = 1
  Axis_Lines(3).p2 = 4

  BoolRotateXY = True
  BoolMoveXY = False
  BoolMoveXZ = False
  BoolShowAxis = True
  DblDrawScale = 1

  LngPriority = THREAD_PRIORITY_NORMAL
  LngJDC = CreateCompatibleDC(Picture1.hdc)
  LngBluePen = CreatePen(0, 1, &HFF0000)
  LngGreenPen = CreatePen(0, 1, &HFF000)
  LngRedPen = CreatePen(0, 1, &HFF)
  LngWhitePen = CreatePen(0, 1, &HFFFFFF)
  LngGreyPen = CreatePen(0, 1, &H333333)
  VarRetVal = CreateCompatibleBitmap(Picture1.hdc, Picture1.Width, Picture1.Height)
  VarRetVal = SelectObject(LngJDC, VarRetVal)

  LngModelPen = CreatePen(PS_Solid, 1, &HFFFFFF)
  VarRetVal = SelectObject(LngJDC, LngModelPen)

  BrushType.lbColor = &H808080

  Lngpbrush = CreateBrushIndirect(BrushType)
  VarRetVal = SelectObject(LngJDC, Lngpbrush)

Camera.x = Radians(45)
Camera.y = Radians(45)
Camera.m3 = -700
LngWid = Picture1.Width / 2
ReDim Lines(2)
Lines(2).p1 = 1
Lines(2).p2 = 1


Mat_World = Mat_Rotate(Radians(1), Radians(1))
Refresh_Display

Call Engine_Render
End Sub

Public Function Engine_Render()
  Dim t As Long

  LngMSECS = GetTickCount()
  t = LngMSECS

  LngThread = GetCurrentThread()
  VarRetVal = SetThreadPriority(LngThread, LngPriority)
  VarRetVal = Rectangle(LngJDC, 0, 0, Picture1.Width, Picture1.Height)

  If LngNum_Lines = 0 Or LngNum_Points = 0 Then GoTo drawaxis

  For LngI = 1 To LngNum_Points
    points(LngI) = transform(Original(LngI), Mat_World)
  Next LngI
    
  Call Transform_3d
  LngRenderTime = GetTickCount() - LngMSECS
  LngMSECS = GetTickCount()
  '--- draw ---
  If Not BoolSolid Then
    For LngI = 1 To LngNum_Lines
        If BoolLEDs(Int((LngI - 1) / 12) + 1) = True Then
          VarRetVal = SelectObject(LngJDC, LngWhitePen)
        Else
          VarRetVal = SelectObject(LngJDC, LngGreyPen)
        End If
        VarRetVal = MoveToEx(LngJDC, Vertex_Buffer(Lines(LngI).p1).m1 * DblDrawScale + LngWid, Vertex_Buffer(Lines(LngI).p1).m2 * DblDrawScale + LngWid, Ret_PT)
        VarRetVal = LineTo(LngJDC, Vertex_Buffer(Lines(LngI).p2).m1 * DblDrawScale + LngWid, Vertex_Buffer(Lines(LngI).p2).m2 * DblDrawScale + LngWid)
    Next LngI
  End If

drawaxis:
  If BoolShowAxis Then
    If Not BoolTransform_Model Then
      For LngI = 1 To 4
        tmp_axis(LngI) = transform(Axis_Points(LngI), Mat_World)
      Next LngI
      For Lngj = 1 To 4
        DblCX = 0 - Camera.m1 + tmp_axis(Lngj).m1
        DblCY = 0 - Camera.m2 + tmp_axis(Lngj).m2
        DblCZ = 0 - Camera.m3 + tmp_axis(Lngj).m3
        If DblCZ > 0 Then
          tmp_axis(Lngj).m2 = DblCY * (500 / DblCZ)
          tmp_axis(Lngj).m1 = DblCX * (500 / DblCZ)
        End If
      Next Lngj
    Else
      If BoolRotateXY Then
        For LngI = 1 To 4
          tmp_axis(LngI) = Axis_Points(LngI)
        Next LngI
      ElseIf BoolMoveXZ Then
        For LngI = 1 To 4
          tmp_axis(LngI) = Axis_Points(LngI)
        Next LngI
      ElseIf BoolMoveXY Then
        For LngI = 1 To 4
          tmp_axis(LngI) = Axis_Points(LngI)
        Next LngI
      End If
    End If
        
    DblCX = 0 - Camera.m1 + tmp_axis(5).m1
    DblCY = 0 - Camera.m2 + tmp_axis(5).m2
    DblCZ = 0 - Camera.m3 + tmp_axis(5).m3

    VarRetVal = SelectObject(LngJDC, LngBluePen)
    VarRetVal = MoveToEx(LngJDC, tmp_axis(Axis_Lines(1).p1).m1 + LngWid, tmp_axis(Axis_Lines(1).p1).m2 + LngWid, Ret_PT)
    VarRetVal = LineTo(LngJDC, tmp_axis(Axis_Lines(1).p2).m1 + LngWid, tmp_axis(Axis_Lines(1).p2).m2 + LngWid)
    VarRetVal = DeleteObject(Lngpbrush)
    
    VarRetVal = SelectObject(LngJDC, LngGreenPen)
    VarRetVal = MoveToEx(LngJDC, tmp_axis(Axis_Lines(2).p1).m1 + LngWid, tmp_axis(Axis_Lines(2).p1).m2 + LngWid, Ret_PT)
    VarRetVal = LineTo(LngJDC, tmp_axis(Axis_Lines(2).p2).m1 + LngWid, tmp_axis(Axis_Lines(2).p2).m2 + LngWid)
    VarRetVal = DeleteObject(Lngpbrush)
  
    VarRetVal = SelectObject(LngJDC, LngRedPen)
    VarRetVal = MoveToEx(LngJDC, tmp_axis(Axis_Lines(3).p1).m1 + LngWid, tmp_axis(Axis_Lines(3).p1).m2 + LngWid, Ret_PT)
    VarRetVal = LineTo(LngJDC, tmp_axis(Axis_Lines(3).p2).m1 + LngWid, tmp_axis(Axis_Lines(3).p2).m2 + LngWid)
    VarRetVal = DeleteObject(Lngpbrush)

    VarRetVal = SelectObject(LngJDC, LngModelPen)
  End If

  '------------------------------------------------------------------------------------------------------------------
  VarRetVal = BitBlt(Picture1.hdc, 0, 0, Picture1.Width, Picture1.Height, LngJDC, 0, 0, SRCCOPY)
  VarRetVal = SetThreadPriority(LngThread, THREAD_PRIORITY_NORMAL)

  LngDrawTime = GetTickCount() - LngMSECS
  If (GetTickCount - LngLastF) > 1500 Then
    If t <> GetTickCount() Then
      LngFrames = 1000 / (GetTickCount() - t)
    Else
      LngFrames = 50
    End If
    'Label5.Caption = LngFrames

    If LngFrames > LngMaxLngFPS Then
        LngMaxLngFPS = LngFrames
        'Label8.Caption = LngMaxLngFPS
        'Label8.Refresh
    End If
    LngLastF = GetTickCount
  End If
End Function

Public Function Transform_3d()
  ReDim Vertex_Buffer(LngNum_Points)

  If LngNum_Points = 0 Then Exit Function


  For LngI = 1 To LngNum_Points
    DblCX = 0 - Camera.m1 + points(LngI).m1
    DblCY = 0 - Camera.m2 + points(LngI).m2
    DblCZ = 0 - Camera.m3 + points(LngI).m3

    If DblCZ > 1 Then
      Vertex_Buffer(LngI).m2 = DblCY * (500 / DblCZ)
      Vertex_Buffer(LngI).m1 = DblCX * (500 / DblCZ)
    End If
  Next LngI
End Function


Private Sub DrawCube()
  Dim p1, p2, p3, p4, p5, p6, p7, p8 As Long
  Dim x, y, z As Double
  Dim a, b, c As Double

  x = 3
  y = 3
  z = 3
  
  For a = -140 To 140 Step 40
    For b = -140 To 140 Step 40
      For c = -140 To 140 Step 40
        AddPoint a - x, b - y, c - z
        p1 = LngNum_Points
        AddPoint a + x, b - y, c - z
        p2 = LngNum_Points
        AddPoint a + x, b - y, c + z
        p3 = LngNum_Points
        AddPoint a - x, b - y, c + z
        p4 = LngNum_Points
        AddPoint a - x, b + y, c - z
        p5 = LngNum_Points
        AddPoint a + x, b + y, c - z
        p6 = LngNum_Points
        AddPoint a + x, b + y, c + z
        p7 = LngNum_Points
        AddPoint a - x, b + y, c + z
        p8 = LngNum_Points
        AddLine p1, p2
        AddLine p2, p3
        AddLine p3, p4
        AddLine p4, p1
        AddLine p5, p6
        AddLine p6, p7
        AddLine p7, p8
        AddLine p8, p5
        AddLine p1, p5
        AddLine p2, p6
        AddLine p3, p7
        AddLine p4, p8

        If BoolTransform_Model Then
          Mat_World = Mat_Rotate(0, 0)
          Engine_Render
        Else
          Mat_World = Mat_Rotate(DblXsum, DblYsum)
          Engine_Render
        End If
      Next c
    Next b
  Next a
  Refresh_Display
End Sub

Private Sub Form_Resize()
  If BoolStart = False Then
    Exit Sub
  Else
    BoolStart = False
    DrawCube
  End If
End Sub

Private Sub Picture1_Paint()
  VarRetVal = BitBlt(Picture1.hdc, 0, 0, Picture1.Width, Picture1.Height, LngJDC, 0, 0, SRCCOPY)
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If BoolDraw = True Then Exit Sub

  Picture1.AutoRedraw = False
  If BoolRotateXY Then
    If BoolTransform_Model Then
      DblYaxis = 0
      DblXaxis = 0
      Mat_World = Mat_Rotate(DblXaxis, DblYaxis)
    Else
      DblYaxis = DblYsum
      DblXaxis = DblXsum
      Mat_World = Mat_Rotate(DblXaxis, DblYaxis)
    End If
  ElseIf BoolMoveXY Then
    If BoolTransform_Model Then
      DblYaxis = 0
      DblXaxis = 0
      Mat_World = Mat_Move(DblXaxis, DblYaxis, 0)
    Else
      DblYaxis = DblYsum
      DblXaxis = DblXsum
      Mat_World = Mat_Move(DblXaxis, DblYaxis, 0)
    End If
  ElseIf BoolMoveXZ Then
    If BoolTransform_Model Then
      DblZaxis = 0
      DblXaxis = 0
      Mat_World = Mat_Move(DblXaxis, 0, DblZaxis)
    Else
      DblZaxis = DblZsum
      DblXaxis = DblXsum
      Mat_World = Mat_Move(DblXaxis, 0, DblZaxis)
    End If
  End If

  Refresh_Display
  Call Engine_Render
  BoolDraw = True
  VarRetVal = GetCursorPos(Last)
End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  If BoolDraw = True And BoolRendering = False Then
    BoolRendering = True
    VarRetVal = GetCursorPos(NewPos)
    If BoolRotateXY Then
      If BoolTransform_Model Then
        DblYaxis = ((NewPos.x - Last.x) / 30) * 2 * PI
        DblXaxis = ((Last.y - NewPos.y) / 15) * PI
        Mat_World = Mat_Rotate(DblXaxis, DblYaxis)
      Else
        DblYaxis = DblYsum + ((NewPos.x - Last.x) / 30) * 2 * PI
        DblXaxis = DblXsum + ((Last.y - NewPos.y) / 15) * PI
        Mat_World = Mat_Rotate(DblXaxis, DblYaxis)
      End If
    ElseIf BoolMoveXY Then
      If BoolTransform_Model Then
        DblYaxis = (NewPos.y - Last.y)
        DblXaxis = (NewPos.x - Last.x)
        Mat_World = Mat_Move(DblXaxis, DblYaxis, 0)
      Else
        DblYaxis = DblYsum + (NewPos.y - Last.y)
        DblXaxis = DblXsum + (NewPos.x - Last.x)
        Mat_World = Mat_Move(DblXaxis, DblYaxis, 0)
      End If
    ElseIf BoolMoveXZ Then
      If BoolTransform_Model Then
        DblZaxis = (NewPos.y - Last.y)
        DblXaxis = (NewPos.x - Last.x)
        Mat_World = Mat_Move(DblXaxis, 0, DblZaxis)
      Else
        DblZaxis = DblZsum + (Last.y - NewPos.y)
        DblXaxis = DblXsum + (NewPos.x - Last.x)
        Mat_World = Mat_Move(DblXaxis, 0, DblZaxis)
      End If
    End If
    
    Refresh_Display
    Call Engine_Render
    BoolRendering = False
  End If
End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  BoolDraw = False
  DblXsum = DblXaxis
  DblYsum = DblYaxis
  DblZsum = DblZaxis

  If BoolTransform_Model Then
    For LngI = 0 To LngNum_Points
      Original(LngI) = points(LngI)
    Next LngI
  End If

  Picture1.AutoRedraw = False
End Sub

Public Sub UpdateScreen()
  Picture1_MouseDown 0, 0, 0, 0
  Picture1_MouseMove 0, 0, 0, 0
  Picture1_MouseUp 0, 0, 0, 0
End Sub
