Attribute VB_Name = "ModEngine3D"
Option Explicit

Public Declare Function SetThreadPriority Lib "kernel32" (ByVal hThread As Long, ByVal nPriority As Long) As Long
Public Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function setCursorPos Lib "user32" (x As Long, y As Long) As Long
Public Declare Function GetCurrentThread Lib "kernel32" () As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateBrushIndirect Lib "gdi32" (lpLogBrush As LOGBRUSH) As Long

Public Const THREAD_BASE_PRIORITY_IDLE = -15
Public Const THREAD_BASE_PRIORITY_LOWRT = 15
Public Const THREAD_BASE_PRIORITY_MAX = 2
Public Const THREAD_BASE_PRIORITY_MIN = -2
Public Const THREAD_PRIORITY_LOWEST = THREAD_BASE_PRIORITY_MIN
Public Const THREAD_PRIORITY_IDLE = THREAD_BASE_PRIORITY_IDLE
Public Const THREAD_PRIORITY_BELOW_NORMAL = (THREAD_PRIORITY_LOWEST + 1)
Public Const THREAD_PRIORITY_NORMAL = 0
Public Const THREAD_PRIORITY_HIGHEST = THREAD_BASE_PRIORITY_MAX
Public Const THREAD_PRIORITY_ABOVE_NORMAL = (THREAD_PRIORITY_HIGHEST - 1)
Public Const THREAD_PRIORITY_TIME_CRITICAL = THREAD_BASE_PRIORITY_LOWRT
Public Const WHITE_BRUSH = 0
Public Const PS_Solid = 0
Public Const PS_DASH = 1                    '  -------
Public Const PS_DASHDOT = 3                 '  _._._._
Public Const PS_DASHDOTDOT = 4              '  _.._.._
Public Const PS_DOT = 2                     '  .......
Public Const PS_ENDCAP_FLAT = &H200
Public Const PS_ENDCAP_MASK = &HF00
Public Const PS_ENDCAP_ROUND = &H0
Public Const PS_ENDCAP_SQUARE = &H100
Public Const BLACK_PEN = 7
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const BS_Solid = 0
Public Const BS_NULL = 1
Public Const BS_OWNERDRAW = &HB&
Public Const BS_PATTERN = 3
Public Const BS_PATTERN8X8 = 7
Public Const BS_PUSHBUTTON = &H0&
Public Const BS_RADIOBUTTON = &H4&
Public Const PI = 3.14159265358979

Public Type LOGBRUSH
        lbStyle As Long
        lbColor As Long
        lbHatch As Long
End Type

Public Type POINTAPI
x As Long
y As Long
End Type

Type View_Camera
    x As Double
    y As Double
    m1 As Double
    m2 As Double
    m3 As Double
End Type

Type lineslist
    p1 As Integer
    p2 As Integer
End Type

Type pointlist
    x As Double
    y As Double
    z As Double
End Type

Type vertex
    m1 As Double
    m2 As Double
    m3 As Double
    m4 As Double
End Type

Type worldmat
    m11 As Double
    m12 As Double
    m13 As Double
    m14 As Double
    m21 As Double
    m22 As Double
    m23 As Double
    m24 As Double
    m31 As Double
    m32 As Double
    m33 As Double
    m34 As Double
    m41 As Double
    m42 As Double
    m43 As Double
    m44 As Double
End Type

Public Function Reset_Display()
LngMaxLngFPS = 0
LngFPS = 0
Mat_World.m11 = 0
Mat_World.m12 = 0
Mat_World.m13 = 0
Mat_World.m14 = 0

Mat_World.m21 = 0
Mat_World.m22 = 0
Mat_World.m23 = 0
Mat_World.m24 = 0

Mat_World.m31 = 0
Mat_World.m32 = 0
Mat_World.m33 = 0
Mat_World.m34 = 0

Mat_World.m41 = 0
Mat_World.m42 = 0
Mat_World.m43 = 0
Mat_World.m44 = 0

End Function

Public Function Restore_position()
  For LngI = 1 To LngNum_Points
    points(LngI) = Original(LngI)
  Next LngI
End Function

Public Function Refresh_Display()
  If BoolRotateXY Then
    If DblXaxis >= 0 Then
      FrmInfo.LblXAxis.Caption = Format$(Int(DblXaxis * 1000) / 1000, "+000.00") + ""
    Else
      FrmInfo.LblXAxis.Caption = Format$(Int(DblXaxis * 1000) / 1000, "000.00") + ""
    End If
    If DblYaxis >= 0 Then
      FrmInfo.LblYAxis.Caption = Format$(Int(DblYaxis * 1000) / 1000, "+000.00") + ""
    Else
      FrmInfo.LblYAxis.Caption = Format$(Int(DblYaxis * 1000) / 1000, "000.00") + ""
    End If
  Else
    If DblXaxis >= 0 Then
      FrmInfo.LblXAxis.Caption = Format$(Int(DblXaxis * 1000) / 1000, "+000.00")
    Else
      FrmInfo.LblXAxis.Caption = Format$(Int(DblXaxis * 1000) / 1000, "000.00")
    End If
    If DblYaxis >= 0 Then
      FrmInfo.LblYAxis.Caption = Format$(Int(DblYaxis * 1000) / 1000, "+000.00")
    Else
      FrmInfo.LblYAxis.Caption = Format$(Int(DblYaxis * 1000) / 1000, "000.00")
    End If
  End If

  FrmInfo.LblRenderTime.Caption = Str$(LngRenderTime) + " ms"
  FrmInfo.LblDrawTime.Caption = Str$(LngDrawTime) + " ms"

  If LngFPS <> 0 Then
    FrmInfo.LblFrameRate.Caption = CStr(LngFPS) & " FPS"
  End If
  If LngMaxLngFPS <> 0 Then
    FrmInfo.LblMaxFrameRate.Caption = CStr(LngMaxLngFPS) & " FPS"
  End If
End Function

Public Function AddLine(ByVal p1 As Integer, ByVal p2 As Integer)
  If Not BoolIgnore And (p2 < 0 Or p1 < 0 Or p1 > LngNum_Points Or p2 > LngNum_Points) Then
    Exit Function
  Else
    ReDim Preserve Lines(LngNum_Lines + 1)
    LngNum_Lines = LngNum_Lines + 1
    Lines(LngNum_Lines).p1 = p1
    Lines(LngNum_Lines).p2 = p2
  End If
End Function

Public Function AddPoint(ByVal x As Double, ByVal y As Double, ByVal z As Double)
  LngNum_Points = LngNum_Points + 1
  ReDim Preserve points(LngNum_Points + 1)
  ReDim Preserve Original(LngNum_Points + 1)
  Full_Mat = Mat_Rotate(DblXsum, DblYsum)
  Original(LngNum_Points).m1 = x
  Original(LngNum_Points).m2 = -y
  Original(LngNum_Points).m3 = z
  Original(LngNum_Points).m4 = 1
  points(LngNum_Points) = transform(Original(LngNum_Points), Full_Mat)
End Function

Public Function Mat_multiply(Mat_1 As worldmat, Mat_2 As worldmat) As worldmat
  Mat_multiply.m11 = Mat_2.m11 * Mat_2.m11 + Mat_1.m12 * Mat_2.m21 + Mat_1.m13 * Mat_2.m31 + Mat_1.m14 * Mat_2.m41
  Mat_multiply.m12 = Mat_2.m11 * Mat_2.m12 + Mat_1.m12 * Mat_2.m22 + Mat_1.m13 * Mat_2.m32 + Mat_1.m14 * Mat_2.m42
  Mat_multiply.m13 = Mat_2.m11 * Mat_2.m13 + Mat_1.m12 * Mat_2.m23 + Mat_1.m13 * Mat_2.m33 + Mat_1.m14 * Mat_2.m43
  Mat_multiply.m14 = Mat_2.m11 * Mat_2.m14 + Mat_1.m12 * Mat_2.m24 + Mat_1.m13 * Mat_2.m34 + Mat_1.m14 * Mat_2.m44
  Mat_multiply.m21 = Mat_2.m21 * Mat_2.m11 + Mat_1.m22 * Mat_2.m21 + Mat_1.m23 * Mat_2.m31 + Mat_1.m24 * Mat_2.m41
  Mat_multiply.m22 = Mat_2.m21 * Mat_2.m12 + Mat_1.m22 * Mat_2.m22 + Mat_1.m23 * Mat_2.m32 + Mat_1.m24 * Mat_2.m42
  Mat_multiply.m23 = Mat_2.m23 * Mat_2.m33 + Mat_1.m22 * Mat_2.m23 + Mat_1.m23 * Mat_2.m33 + Mat_1.m24 * Mat_2.m43
  Mat_multiply.m24 = Mat_2.m24 * Mat_2.m44 + Mat_1.m22 * Mat_2.m24 + Mat_1.m23 * Mat_2.m34 + Mat_1.m24 * Mat_2.m44
  Mat_multiply.m31 = Mat_2.m31 * Mat_2.m11 + Mat_1.m32 * Mat_2.m21 + Mat_1.m33 * Mat_2.m31 + Mat_1.m34 * Mat_2.m41
  Mat_multiply.m32 = Mat_2.m32 * Mat_2.m12 + Mat_1.m32 * Mat_2.m22 + Mat_1.m33 * Mat_2.m32 + Mat_1.m34 * Mat_2.m42
  Mat_multiply.m33 = Mat_2.m33 * Mat_2.m13 + Mat_1.m32 * Mat_2.m23 + Mat_1.m33 * Mat_2.m33 + Mat_1.m34 * Mat_2.m43
  Mat_multiply.m34 = Mat_2.m34 * Mat_2.m14 + Mat_1.m32 * Mat_2.m24 + Mat_1.m33 * Mat_2.m34 + Mat_1.m34 * Mat_2.m44
  Mat_multiply.m41 = Mat_2.m41 * Mat_2.m11 + Mat_1.m42 * Mat_2.m21 + Mat_1.m43 * Mat_2.m31 + Mat_1.m44 * Mat_2.m41
  Mat_multiply.m42 = Mat_2.m42 * Mat_2.m12 + Mat_1.m42 * Mat_2.m22 + Mat_1.m43 * Mat_2.m32 + Mat_1.m44 * Mat_2.m42
  Mat_multiply.m43 = Mat_2.m43 * Mat_2.m13 + Mat_1.m42 * Mat_2.m23 + Mat_1.m43 * Mat_2.m33 + Mat_1.m44 * Mat_2.m43
  Mat_multiply.m44 = Mat_2.m44 * Mat_2.m14 + Mat_1.m42 * Mat_2.m24 + Mat_1.m43 * Mat_2.m34 + Mat_1.m44 * Mat_2.m44
End Function

Public Function f(ByVal x As Double, ByVal z As Double) As Double
  f = 25 * Cos(Radians((Sqr(x * x + z * z) / 255) * 800))
End Function

Public Function transform(point As vertex, mat_transform As worldmat) As vertex
  transform.m1 = point.m1 * mat_transform.m11 + point.m2 * mat_transform.m12 + point.m3 * mat_transform.m13 + point.m4 * mat_transform.m14
  transform.m2 = point.m1 * mat_transform.m21 + point.m2 * mat_transform.m22 + point.m3 * mat_transform.m23 + point.m4 * mat_transform.m24
  transform.m3 = point.m1 * mat_transform.m31 + point.m2 * mat_transform.m32 + point.m3 * mat_transform.m33 + point.m4 * mat_transform.m34
  transform.m4 = point.m1 * mat_transform.m41 + point.m2 * mat_transform.m42 + point.m3 * mat_transform.m43 + point.m4 * mat_transform.m44
End Function

Public Function Radians(degrees As Double) As Double
  Radians = (Atn(1) / 45) * degrees
End Function

Public Function Mat_Rotate(x As Double, y As Double) As worldmat
  Mat_Rotate.m11 = Cos(Radians(y))
  Mat_Rotate.m12 = Sin(Radians(x)) * Sin(Radians(y))
  Mat_Rotate.m13 = Cos(Radians(x)) * (-1 * Sin(Radians(y)))
  Mat_Rotate.m14 = 0
  Mat_Rotate.m21 = 0
  Mat_Rotate.m22 = Cos(Radians(x))
  Mat_Rotate.m23 = Sin(Radians(x))
  Mat_Rotate.m24 = 0
  Mat_Rotate.m31 = Sin(Radians(y))
  Mat_Rotate.m32 = Cos(Radians(y)) * (-1 * Sin(Radians(x)))
  Mat_Rotate.m33 = Cos(Radians(y)) * Cos(Radians(x))
  Mat_Rotate.m34 = 0
  Mat_Rotate.m41 = 0
  Mat_Rotate.m42 = 0
  Mat_Rotate.m43 = 0
  Mat_Rotate.m44 = 1
End Function

Public Function Mat_Move(x As Double, y As Double, z As Double) As worldmat
  Mat_Move.m11 = 1
  Mat_Move.m12 = 0
  Mat_Move.m13 = 0
  Mat_Move.m14 = x
  Mat_Move.m21 = 0
  Mat_Move.m22 = 1
  Mat_Move.m23 = 0
  Mat_Move.m24 = y
  Mat_Move.m31 = 0
  Mat_Move.m32 = 0
  Mat_Move.m33 = 1
  Mat_Move.m34 = z
  Mat_Move.m41 = 0
  Mat_Move.m42 = 0
  Mat_Move.m43 = 0
  Mat_Move.m44 = 1
End Function
    
Public Function c_degrees(Radians As Double)
  c_degrees = (Radians / Atn(1)) * 45
End Function

Public Function GetFile(Filename As String)
    Dim Path As String
    Dim Fnum As Integer

    '---read file in one pass!
    Fnum = FreeFile
    Open Filename For Input As #Fnum
        GetFile = Input(LOF(Fnum), Fnum)
    Close Fnum
    Exit Function
    
ErrorHandler:
    Err.Description = "GetFile: " & Err.Description & " -> " & Filename
    Err.Raise Err.Number
End Function

